﻿namespace MobileOSGeekOxygeneTutorial;

interface

uses
  System,
  System.Collections.Generic,
  System.Linq,
  System.Net,
  System.Windows,
  System.Windows.Controls,
  System.Windows.Media,
  System.Windows.Navigation,
  Microsoft.Phone.Controls,
  Microsoft.Phone.Shell,
  MobileOSGeekOxygeneTutorial.Resources,
  Microsoft.Phone.Tasks,
  Microsoft.Phone.BackgroundAudio,
  System.IO.IsolatedStorage;
type
  MainPage = public partial class(PhoneApplicationPage)

  public
    // Constructor
    constructor ;
    method PlaySong;
    method CopyToIsolatedSorage;
  private
      method btnLaunch_Click(sender: Object; e: System.Windows.RoutedEventArgs);
  end;

implementation

constructor MainPage;
begin
  InitializeComponent()

end;

method MainPage.btnLaunch_Click(sender: Object; e: System.Windows.RoutedEventArgs);
begin
     CopyToIsolatedSorage();
     PlaySong();
end;

// Method to Play Song
method MainPage.PlaySong;
begin
  var tracks: List<AudioTrack> := new List<AudioTrack>();
  tracks.Add(new AudioTrack(new Uri('music1.mp3', UriKind.Relative), 'MobileOSGeek Music', 'MobileOSGeek Music', 'MobileOSGeek Music', nil));
  var track := tracks.FirstOrDefault();
  BackgroundAudioPlayer.Instance.Track := track;
  BackgroundAudioPlayer.Instance.Play()
end;

// Copy the File to Isolated Storage
method MainPage.CopyToIsolatedSorage;
begin
  using storage: IsolatedStorageFile := IsolatedStorageFile.GetUserStoreForApplication() do begin
    var fileName: System.String := 'music1.mp3';
    if not storage.FileExists(fileName) then begin
      var resource: System.Windows.Resources.StreamResourceInfo := Application.GetResourceStream(new Uri(fileName, UriKind.Relative));

      using file: IsolatedStorageFileStream := storage.CreateFile(fileName) do begin
        var chunkSize: System.Int32 := 4096;
        var bytes: array of System.Byte := new System.Byte[chunkSize];
        var byteCount: System.Int32;

        loop begin
          byteCount := resource.Stream.Read(bytes, 0, chunkSize);
          file.Write(bytes, 0, byteCount);

          if not(byteCount > 0) then break;
        end;
      end
    end
  end;
  using storage: IsolatedStorageFile := IsolatedStorageFile.GetUserStoreForApplication() do begin
  end
end;


end.